﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Vezérek száma: ");
            N = Convert.ToInt32(Console.ReadLine());
        }

        static bool rossz(int i, int j, int[] x)
        {
            int k = 1;
            while (k < i && x[k - 1] != j && i-k != Math.Abs(j-x[k-1]))
            {
                k++;
            }
            return k < i;
        }
        
        static void Jóesetkeresés(int N, int i, int[] Y, out bool Van, ref int j)
        {
            j = Y[i - 1] + 1;
            while (j <= N && rossz(i, j, Y))
            {
                j++;
            }
            Van = j <= N;
        }

        static void Vezérek(int N, out bool Van, int[] Y)
        {
            for (int ii = 0; ii < N; ii++)
            {
                Y[ii] = 0;
            }
            int i = 1;
            while (i >= 1 && i <= N)
            {
                int j=0;
                Jóesetkeresés(N, i, Y, out Van, ref j);
                if (Van)
                {
                    Y[i - 1] = j;
                    i++;
                }
                else
                {
                    Y[i - 1] = 0;
                    i--;
                }
            }
            Van = i > N;
        }

        static void Kiírás(int N, bool Van, int[] Y)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            if (Van)
            {
                for (int i = 0; i < N; i++)
                {
                    Console.WriteLine(Y[i] + " ");
                }
                Console.WriteLine();
            }
            else
            {
                Console.WriteLine("Nincs helyes megoldás!");
            }
        }

        static void Main(string[] args)
        {
            //N vezér elhelyezése egy NxN-es sakktáblán
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            //A mátrix deklarálása
            int[] Y = new int[MaxN];
            //Kieneti adatok deklarálása
            bool Van;
            //Beolvasás
            Beolvasás(out N);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Vezérek(N,out Van,Y);
            //Kiírás
            Kiírás(N, Van, Y);
        }
    }
}
