﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, int[] D, int[,] E)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Munkák száma: ");
            N = Convert.ToInt32(Console.ReadLine());
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine((i + 1) + ". munkás vállalt munkáinak száma: ");
                string input = Console.ReadLine();//Egy sorban több adat van
                string[] adatok = input.Split(' ');
                int adatindex = 0;
                D[i] = Convert.ToInt32(adatok[adatindex]);
                adatindex++;
                for (int j = 0; j < D[i]; j++)
                {
                    Console.Error.WriteLine((j + 1) + ". vállalt munka sorszáma: ");
                    E[i,j] = Convert.ToInt32(adatok[adatindex]);
                    adatindex++;
                }
            }
        }

        static bool rossz(int i, int j, int[,] E, int[] Y)
        {
            int k = 1;
            while (k < i && E[k - 1,Y[k - 1] - 1] != E[i - 1,j - 1])
            {
                k++;
            }
            return k < i;
        }
        
        static void Jóesetkeresés(int i, int[] D, int[,] E, int[] Y, out bool Van, ref int j)
        {
            j = Y[i - 1] + 1;
            while (j <= D[i - 1] && rossz(i, j, E, Y))
            {
                j++;
            }
            Van = j <= D[i - 1];
        }

        static void Munkák(int N, int[] D, int[,] E, out bool Van, int[] Y)
        {
            for (int ii = 0; ii < N; ii++)
            {
                Y[ii] = 0;
            }
            int i = 1;
            while (i >= 1 && i <= N)
            {
                int j = 0;
                Jóesetkeresés(i, D, E, Y, out Van, ref j);
                if (Van)
                {
                    Y[i - 1] = j;
                    i++;
                }
                else
                {
                    Y[i - 1] = 0;
                    i--;
                }
            }
            Van = i > N;
            if (Van)
            {
                for (int ii = 1; ii <= N; ii++)
                {
                    Y[ii - 1] = E[ii - 1, Y[ii - 1] - 1];
                }
            }
        }

        static void Kiírás(int N, bool Van, int[] Y)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            if (Van)
            {
                for (int i = 0; i < N; i++)
                {
                    Console.WriteLine(Y[i] + " ");
                }
                Console.WriteLine();
            }
            else
            {
                Console.WriteLine("Nincs helyes megoldás!");
            }
        }

        static void Main(string[] args)
        {
            //Munkásfelvétel: N állás – N jelentkező
            //Maximális elemszám
            const int MaxN = 100;
            //A munkások száma
            int N;
            //A tömbök, mátrix deklarálása
            int[] D = new int[MaxN];//Ki mennyi munkához ért
            int[,] E = new int[MaxN, MaxN]; //Ki mihez ért
            //Kieneti adatok deklarálása
            bool Van;
            int[] Y = new int[MaxN];//Munkasorszám
            //Beolvasás
            Beolvasás(out N, D, E);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Munkák(N,D,E,out Van,Y);
            //Kiírás
            Kiírás(N, Van, Y);
        }
    }
}
