import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    //static PrintStream cerr = System.err;
    static final int MaxN = 100;

    static class VezerekResponse {
        public boolean VAN;
        public int Y[] = new int[MaxN];
    }

    static class JoesetkeresesResponse {
        public boolean VAN;
        public int j;
    }

    static int beolvas(IO io) throws IOException {
        return io.nextInt();
    }

    static boolean rossz(int i, int j, int Y[]) {
        int k = 1;
        //cerr.println("i:" + i);
        //cerr.println("j:" + j);
        //cerr.println("k:" + k);
        //cerr.println("Y[k]:" + Y[k - 1]);
        while ((k < i) && (Y[k - 1] != j) && ((i - k) != Math.abs(j - Y[k - 1]))) {
            k = k + 1;
        }
        //cerr.println("j:" + j);
        //cerr.println("k:" + k);
        return (k < i);
    }

    static JoesetkeresesResponse joesetkereses(int N, int i, int Y[]) {
        JoesetkeresesResponse response = new JoesetkeresesResponse();
        response.j = Y[i - 1] + 1;
        //cerr.println(j);
        while ((response.j <= N) && rossz(i, response.j, Y)) {
            response.j = response.j + 1;
            //cerr.println(j);
        }
        //cerr.println(j);
        response.VAN = (response.j <= N);
        return response;
    }

    static VezerekResponse vezerek(int N) {
        VezerekResponse response = new VezerekResponse();
        for (int i1 = 0; i1 < N; i1++) {
            response.Y[i1] = 0;
        }
        int i = 1;
        while ((i >= 1) && (i <= N)) {
            //cerr.println();
            JoesetkeresesResponse joesetkeresesResponse = joesetkereses(N, i, response.Y);
            if (joesetkeresesResponse.VAN) {
                response.Y[i - 1] = joesetkeresesResponse.j;
                i = i + 1;
            } else {
                response.Y[i - 1] = 0;
                i = i - 1;
            }
        }
        response.VAN = (i > N);
        return response;
    }

    static void kiir(IO io, int N, VezerekResponse response) throws IOException {
        if (response.VAN) {
            for (int i1 = 0; i1 < N; i1++) {
                io.write(response.Y[i1] + " ");
//                for (int i2 = 1; i2 < Y[i1]; i2++) {
//                    io.write(" ");
//                }
//                io.writeLn("X");
            }
            io.writeLn("");
        } else {
            io.writeLn("Nincs megoldas.");
        }
    }

    public static void main(String[] args) throws Exception {

        IO io = new IO();

        int N = beolvas(io);

        VezerekResponse vezerekResponse = vezerek(N);

        kiir(io, N, vezerekResponse);

        io.close();

    }

}