import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;

public class feladat {

    public feladat() {
    }

    //static PrintStream cerr = System.err;
    static final int MaxN = 100;

    static class Input {
        int N;
        int D[] = new int[MaxN];
        int E[][] = new int[MaxN][MaxN];
    }

    static class Output {
        boolean VAN;
        static int Y[] = new int[MaxN];
    }

    static class JoesetkeresesResponse {
        boolean VAN;
        int j;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
        for (int i1 = 0; i1 < input.N; i1++) {
            input.D[i1] = io.nextInt();
            for (int i2 = 0; i2 < input.D[i1]; i2++) {
                input.E[i1][i2] = io.nextInt();
            }
        }
        return input;
    }

    static boolean rossz(int i, int j, int E[][], int Y[]) {
        int k = 1;
        //cerr.println("i:" + i);
        //cerr.println("j:" + j);
        //cerr.println("k:" + k);
        //cerr.println("Y[k]:" + Y[k - 1]);
        while ((k < i) && (E[k - 1][Y[k - 1] - 1] != E[i - 1][j - 1])) {
            k = k + 1;
        }
        //cerr.println("j:" + j);
        //cerr.println("k:" + k);
        return (k < i);
    }

    static JoesetkeresesResponse joesetkereses(int i, int D[], int E[][], int Y[]) {
        JoesetkeresesResponse response = new JoesetkeresesResponse();
        response.j = Y[i - 1] + 1;
        //cerr.println(j);
        while ((response.j <= D[i - 1]) && rossz(i, response.j, E, Y)) {
            response.j = response.j + 1;
            //cerr.println(j);
        }
        //cerr.println(j);
        response.VAN = (response.j <= D[i - 1]);
        return response;
    }

    static Output munkak(Input input) {
        Output output = new Output();
        for (int i1 = 0; i1 < input.N; i1++) {
            output.Y[i1] = 0;
        }
        int i = 1;
        while ((i >= 1) && (i <= input.N)) {
            //cerr.println();
            JoesetkeresesResponse joesetkeresesResponse = joesetkereses(i, input.D, input.E, output.Y);
            if (joesetkeresesResponse.VAN) {
                output.Y[i - 1] = joesetkeresesResponse.j;
                i = i + 1;
            } else {
                output.Y[i - 1] = 0;
                i = i - 1;
            }
        }
        output.VAN = (i > input.N);
        if (output.VAN) {
            for (int i1 = 0; i1 < input.N; i1++) {
                output.Y[i1] = input.E[i1][output.Y[i1] - 1];
            }
        }
        return output;
    }

    static void kiir(IO io, Input input, Output output) throws IOException {
        if (output.VAN) {
            for (int i1 = 0; i1 < input.N; i1++) {
                io.write(output.Y[i1] + " ");
            }
            io.writeLn("");
        } else {
            io.writeLn("Nincs megoldas.");
        }
    }

    public static void main(String[] args) throws Exception {

        IO io = new IO();

        Input input = beolvas(io);


        Output output = munkak(input);

        kiir(io, input, output);

        io.close();

    }

}