(*
* Input:
*  N -- munkák száma
*  D[1] -- 1. munkás vállalható munkák száma
*  E[1,1] -- 1. munkás által vállalható 1. munka sorszáma
*  ...
*  E[1,D[1]] -- 1. munkás által vállalható D[1]. munka sorszáma
*  ...
*  D[N] -- N. munkás vállalható munkák száma
*  E[N,1] -- N. munkás által vállalható 1. munka sorszáma
*  ...
*  E[N,D[N]] -- N. munkás által vállalható D[N]. munka sorszáma
*)
Program Feladat;
  Const
    MaxN=100;//munkák=munkások maximális száma
  Type
    TKiMennyihezErt=Array [1..MaxN] of Integer;//ki mennyi munkához ért
    TKiMihezErt=Array [1..MaxN,1..MaxN] of Integer;//ki mihez ért
    TMunkaSorszam=Array [1..MaxN] of Integer;//az egyes munkások munkasorszáma
  Var
    //Bemenet
    N:Integer;
    D:TKiMennyihezErt;
    E:TKiMihezErt;
    //Kimenet:
    Van:Boolean;
    Y:TMunkaSorszam;
    
  Procedure Beolvasas;
    Var
      i,j:Integer;
  Begin
    Write(StdErr,'Munkak szama:');
    Readln(N);
    Writeln(StdErr,'Kerem az egyes munkasok altal vallalhato munkakat: "darabszam + munkasorszamok felsorolasa" alakban!');
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'.: munkas altal vallalhato munkak:');
      Read(D[i]);
      For j:=1 to D[i] do
      Begin
         Read(E[i,j]);
      End;
      Readln;
    End;
  End;
  
  Function Rossz(Const i:Integer; Const j:Integer):Boolean;
   Var
     k:Integer;
  Begin
    k:=1;
    While (k<i) and (E[k,Y[k]]<>E[i,j]) do Inc(k);
    Rossz:=k<i;
  End;
  
  Procedure Joesetkereses(Const i:Integer; Var Van:Boolean; Var j:Integer);
  Begin
    j:=Y[i]+1;
    While (j<=D[i]) and Rossz(i,j) do Inc(j);
    Van:=j<=D[i];
  End;
  
  Procedure Munkak(Const N:Integer; Var Van:Boolean; Var Y:TMunkaSorszam);
    Var
      i,j:Integer;
  Begin
    i:=1; For j:=1 to N do Y[j]:=0;
    While (i>=1) and (i<=N) do
    Begin
      Joesetkereses(i,Van,j);
      If Van then 
      Begin
        Y[i]:=j; Inc(i);
      End
        else
      Begin
        Y[i]:=0; Dec(i);
      End;
    End;
    Van:=i>N;
    If Van then
    Begin
      For i:=1 to N do Y[i]:=E[i,Y[i]];
    End;
  End;
  
  Procedure Kiiras;
    Var
      i:Integer;
  Begin
    If Van then
    Begin
      Writeln(StdErr,'Munkas-munkasorszam hozzarendelesek:');
      For i:=1 to N do
      Begin
        Write(Y[i],' ');
      End;
      Writeln;
    End
      else
    Begin
      Writeln('NINCS');
    End;
  End;
  
Begin
  Beolvasas;
  Munkak(N,Van,Y);
  Kiiras;
End.
    
